Bug 1578310 - CSI: It should be possible to run multiple external attachers for the same driver
Summary: CSI: It should be possible to run multiple external attachers for the same dr...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: Storage
Version: 3.10.0
Hardware: Unspecified
OS: Unspecified
unspecified
medium
Target Milestone: ---
: 3.10.0
Assignee: Jan Safranek
QA Contact: Qin Ping
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-05-15 09:10 UTC by Jan Safranek
Modified: 2018-07-30 19:15 UTC (History)
3 users (show)

Fixed In Version: csi-attacher-0.2.0-3.git27299be.el7.src.rpm,
Doc Type: No Doc Update
Doc Text:
undefined
Clone Of:
Environment:
Last Closed: 2018-07-30 19:15:30 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2018:1816 None None None 2018-07-30 19:15:54 UTC

Description Jan Safranek 2018-05-15 09:10:02 UTC
Description of problem:

Only one external attacher must be running for a CSI driver. Two or more of them will conflict with each other and all of them will try to attach one volume to a node.

There should be some sort of leader election so only one attacher attaches a volume. 

Version-Release number of selected component (if applicable):
csi-attacher-0.2.0-2.git27299be.el7

Comment 1 Jan Safranek 2018-05-15 09:10:51 UTC
Upstream PR: https://github.com/kubernetes-csi/external-attacher/pull/48

Comment 2 Jan Safranek 2018-05-15 09:53:45 UTC
I've built csi-attacher-0.2.0-3.git27299be.el7.src.rpm, it should propagate to Docker images and puddles in a few days.

Comment 3 Jan Safranek 2018-05-15 09:56:44 UTC
To be clear, it's possible to use external attacher in a StatefulSet as today, I'll update docs to use Deployments once there are images with the new attacher.

Comment 4 Jan Safranek 2018-05-16 12:07:54 UTC
I noticed csi-attacher-container-v3.10.0-0.47.0.0 image with csi-attacher-0.2.0-3.git27299be.el7.x86_64.rpm was built yesterday and it's availabe in out registry, so you can test it. I updated https://github.com/openshift/openshift-docs/pull/8783 and removed the StatefulSet to simplify the deployment.

Comment 7 Qin Ping 2018-06-06 02:57:32 UTC
Verified in openshift:
oc v3.10.0-0.60.0
openshift v3.10.0-0.60.0
kubernetes v1.10.0+b81c8f8

csi-attacher-0.2.0-3.git27299be.el7.x86_64
csi-provisioner-0.2.0-2.el7.x86_64
csi-driver-registrar-0.2.0-1.el7.x86_64

# uname -a
Linux qe-piqin-master-etcd-nfs-1 3.10.0-862.3.2.el7.x86_64 #1 SMP Tue May 15
18:22:15 EDT 2018 x86_64 x86_64 x86_64 GNU/Linux

# cat /etc/redhat-release 
Red Hat Enterprise Linux Server release 7.5 (Maipo)

Comment 9 errata-xmlrpc 2018-07-30 19:15:30 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHBA-2018:1816


Note You need to log in before you can comment on or make changes to this bug.